# CustomHeightmapTerrainProvider

#### new Cesium.CustomHeightmapTerrainProvider(options)
Core/CustomHeightmapTerrainProvider.js 57

A simple `TerrainProvider` that gets height values from a callback function. It can be used for procedurally generated terrain or as a way to load custom heightmap data without creating a subclass of `TerrainProvider`. There are some limitations such as no water mask, no vertex normals, and no availability, so a full-fledged `TerrainProvider` subclass is better suited for these more sophisticated use cases.

Name | Type | Description
--- | --- | ---
`options` | Object | Object with the following properties:
Name | Type | Description
--- | --- | ---
`callback` | CustomHeightmapTerrainProvider.GeometryCallback | The callback function for requesting tile geometry.
`width` | Number | The number of columns per heightmap tile.
`height` | Number | The number of rows per heightmap tile.
`tilingScheme` | TilingScheme | optional The tiling scheme specifying how the ellipsoidal surface is broken into tiles. If this parameter is not provided, a `GeographicTilingScheme` is used.
`ellipsoid` | Ellipsoid | optional The ellipsoid. If the tilingScheme is specified, this parameter is ignored and the tiling scheme's ellipsoid is used instead. If neither parameter is specified, the WGS84 ellipsoid is used.
`credit` | Credit | String | optional A credit for the data source, which is displayed on the canvas.

##### Example:

    var viewer = new Cesium.Viewer("cesiumContainer", {
      terrainProvider: new Cesium.CustomHeightmapTerrainProvider({
        width: 32,
        height: 32,
        callback: function (x, y, level) {
          return new Float32Array(32 * 32); // all zeros
        },
      }),
    });

##### See:

- TerrainProvider

### Members

#### readonly credit : Credit
Core/CustomHeightmapTerrainProvider.js 118

Gets the credit to display when this terrain provider is active. Typically this is used to credit the source of the terrain.

#### readonly errorEvent : Event
Core/CustomHeightmapTerrainProvider.js 105

Gets an event that is raised when the terrain provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonly hasVertexNormals : Boolean
Core/CustomHeightmapTerrainProvider.js 184

Gets a value indicating whether or not the requested tiles include vertex normals. Vertex normals are not supported by `CustomHeightmapTerrainProvider`, so the return value will always be false.

#### readonly hasWaterMask : Boolean
Core/CustomHeightmapTerrainProvider.js 170

Gets a value indicating whether or not the provider includes a water mask. The water mask indicates which areas of the globe are water rather than land, so they can be rendered as a reflective surface with animated waves. Water mask is not supported by `CustomHeightmapTerrainProvider`, so the return value will always be false.

#### readonly height : Boolean
Core/CustomHeightmapTerrainProvider.js 208

Gets the number of rows per heightmap tile.

#### readonly ready : Boolean
Core/CustomHeightmapTerrainProvider.js 142

Gets a value indicating whether or not the provider is ready for use.

#### readonly readyPromise : Promise.<Boolean>
Core/CustomHeightmapTerrainProvider.js 154

Gets a promise that resolves to true when the provider is ready for use.

#### readonly tilingScheme : TilingScheme
Core/CustomHeightmapTerrainProvider.js 130

Gets the tiling scheme used by this provider.

#### readonly width : Boolean
Core/CustomHeightmapTerrainProvider.js 196

Gets the number of columns per heightmap tile.

### Methods

#### getLevelMaximumGeometricError(level) → Number
Core/CustomHeightmapTerrainProvider.js 263

Gets the maximum geometric error allowed in a tile at a given level.

Name | Type | Description
--- | --- | ---
`level` | Number | The tile level for which to get the maximum geometric error.

##### Returns:

The maximum geometric error.

#### getTileDataAvailable(x, y, level) → Boolean|undefined
Core/CustomHeightmapTerrainProvider.js 277

Determines whether data for a tile is available to be loaded.

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.

##### Returns:

Undefined if not supported, otherwise true or false.

#### loadTileDataAvailability(x, y, level) → undefined|Promise.<void>
Core/CustomHeightmapTerrainProvider.js 293

Makes sure we load availability data for a tile

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.

##### Returns:

Undefined if nothing need to be loaded or a Promise that resolves when all required tiles are loaded

#### requestTileGeometry(x, y, level, request) → Promise.<TerrainData>|undefined
Core/CustomHeightmapTerrainProvider.js 228

Requests the geometry for a given tile. The result includes terrain data and indicates that all child tiles are available.

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.
`request` | Request | optional The request object. Intended for internal use only.

##### Returns:

A promise for the requested geometry. If this method returns undefined instead of a promise, it is an indication that too many requests are already pending and the request will be retried later.

### Type Definitions

#### Cesium.CustomHeightmapTerrainProvider.GeometryCallback(x, y, level) → Int8Array|Uint8Array|Int16Array|Uint16Array|Int32Array|Uint32Array|Float32Array|Float64Array|Array.<Number>|Promise.<(Int8Array|Uint8Array|Int16Array|Uint16Array|Int32Array|Uint32Array|Float32Array|Float64Array|Array.<Number>)>|undefined
Core/CustomHeightmapTerrainProvider.js 12

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.

##### Returns:

An array or a promise to an array of heights in row-major order. If undefined, the globe will render the parent tile.